* 68Kswap_asm (c)2000 Thierry Godefroy.
*
*   word16 rotl16(word16 v, word16 cnt);
*   word16 rotr16(word16 v, word16 cnt);
*   word16 byteswap_16(word16 x);
*   word32 rotl(word32 v, word32 cnt);
*   word32 rotr(word32 v, word32 cnt);
*   word32 byteswap(word32 x);
*

          section   TEXT

          comment   "C68 libmcrypt-nm v0.1.0"

          xdef      _rotl16
          xdef      _rotr16
          xdef      _byteswap_16
          xdef      _rotl
          xdef      _rotr
          xdef      _byteswap

_rotl16   MOVE.L    4(SP),D0
          MOVE.W    D0,D1
          ANDI.W    #$0F,D1
          SWAP      D0
          ROL.W     D1,D0
          RTS

_rotr16   MOVE.L    4(SP),D0
          MOVE.W    D0,D1
          ANDI.W    #$0F,D1
          SWAP      D0
          ROR.W     D1,D0
          RTS
          
_byteswap_16
          MOVE.W    4(SP),D0
          ROL.W     #8,D0
          RTS

_rotl     MOVE.L    4(SP),D0
          MOVE.L    8(SP),D1
          ANDI.W    #$1F,D1
          ROL.L     D1,D0
          RTS

_rotr     MOVE.L    4(SP),D0
          MOVE.L    8(SP),D1
          ANDI.W    #$1F,D1
          ROR.L     D1,D0
          RTS

* XxYyZzTt --> TtZzYyXx

_byteswap MOVE.L    4(SP),D0
          ROL.W     #8,D0
          SWAP      D0
          ROL.W     #8,D0
          RTS

          end
